=== debian/changelog ===
ros-foxy-openvino (2022.2.0-5focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- ngaloppo <nico.galoppo@intel.com>  Tue, 08 Nov 2022 19:01:17 -0000
