=== debian/control ===
Source: ros-foxy-openvino
Section: misc
Priority: optional
Maintainer: ngaloppo <nico.galoppo@intel.com>
Build-Depends: debhelper (>= 9.0.0), ca-certificates, cmake, curl, file, g++-multilib, gcc-multilib, git, git-lfs, libcurl4-openssl-dev, libgtk2.0-dev, libpugixml-dev, libssl-dev, libtbb-dev, libusb-1.0-0-dev, udev, unzip, wget, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-openvino
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ca-certificates, curl, file, g++-multilib, gcc-multilib, git, git-lfs, libcurl4-openssl-dev, libgtk2.0-dev, libpugixml-dev, libssl-dev, libtbb-dev, libusb-1.0-0-dev, ros-foxy-ament-cmake, udev, unzip, wget, ros-foxy-ros-workspace
Description: Intel(r) Distribution of OpenVINO(tm) Toolkit
